#include "SimpleHeap.h"

//  ʱȭ
void HeapInit(Heap* ph, PriorityComp pc) {
    ph->numOfData = 0;
    ph->comp = pc;
}

//   Ȯ
int HIsEmpty(Heap* ph) {
    if (ph->numOfData == 0) {
        return true;
    }
    return false;
}

// θ  ε  ȯ
int GetParentIDX(int idx) {
    return idx / 2;
}

//  ڽ  ε  ȯ
int GetLChildIDX(int idx) {
    return idx * 2;
}

//  ڽ  ε  ȯ
int GetRChildIDX(int idx) {
    return GetLChildIDX(idx) + 1;
}

//   ڽ    켱 ڽ  ε  ȯ
int GetHiPriChildIDX(Heap* ph, int idx) {
    // ڽ 尡  ʴ´ٸ
    if (GetLChildIDX(idx) > ph->numOfData) {
        return 0;
    }
    // ڽ 尡  ڽ  ϳ Ѵٸ
    else if (GetLChildIDX(idx) == ph->numOfData) {
        return GetLChildIDX(idx);
    }
    // ڽ 尡   Ѵٸ, 켱  index ȯ
    else {
        if (ph->comp(ph->heapArr[GetLChildIDX(idx)],
            ph->heapArr[GetRChildIDX(idx)]) < 0) {
            return GetRChildIDX(idx);
        }
        return GetLChildIDX(idx);
    }
}

//   
void HInsert(Heap* ph, HData data) {
    //  尡  ε  idx 
    int idx = ph->numOfData + 1;

    //  尡  ġ Ʈ  ġ ƴ϶ while ݺ
    while (idx != 1) {
        //   θ  켱 Ͽ   켱 ٸ
        if (ph->comp(data, ph->heapArr[GetParentIDX(idx)]) > 0) {
            // θ 带   ,  
            ph->heapArr[idx] = ph->heapArr[GetParentIDX(idx)];
            //  带   ø,  ø ʰ ε  
            idx = GetParentIDX(idx);
        }
        //   켱  ʴٸ
        else {
            break;
        }
    }

    //  带 迭 
    ph->heapArr[idx] = data;
    ph->numOfData++;
}

//   
HData HDelete(Heap* ph) {
    // ȯ    
    HData retData = ph->heapArr[1];
    //    
    HData lastElem = ph->heapArr[ph->numOfData];

    //  Ͱ  ġ  .
    int parentIdx = 1;
    int childIdx;

    // Ʈ  켱  ڽ 带  ݺ 
    while (childIdx = GetHiPriChildIDX(ph, parentIdx)) {
        //   켱 
        if (ph->comp(lastElem, ph->heapArr[childIdx]) >= 0) {
            //   켱  ݺ Ż
            break;
        }
        //  庸 켱 , 񱳴  ġ   ø
        ph->heapArr[parentIdx] = ph->heapArr[childIdx];
        //  尡  ġ   
        // ݺ Żϸ parentIdx   ġ 
        parentIdx = childIdx;
    }
    
    //    
    ph->heapArr[parentIdx] = lastElem;
    ph->numOfData--;
    return retData;
}
